package com.chinaitop.depot.intelligent.ventilation.model;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class StorageFoodbasicinfoExample {
    /**
     * storage_foodbasicinfo
     */
    protected String orderByClause;

    /**
     * storage_foodbasicinfo
     */
    protected boolean distinct;

    /**
     * storage_foodbasicinfo
     */
    protected List<Criteria> oredCriteria;

    public StorageFoodbasicinfoExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    /**
     * storage_foodbasicinfo 2018-05-04
     */
    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(Integer value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(Integer value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(Integer value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(Integer value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(Integer value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<Integer> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<Integer> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(Integer value1, Integer value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(Integer value1, Integer value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andHouseIdIsNull() {
            addCriterion("house_id is null");
            return (Criteria) this;
        }

        public Criteria andHouseIdIsNotNull() {
            addCriterion("house_id is not null");
            return (Criteria) this;
        }

        public Criteria andHouseIdEqualTo(Integer value) {
            addCriterion("house_id =", value, "houseId");
            return (Criteria) this;
        }

        public Criteria andHouseIdNotEqualTo(Integer value) {
            addCriterion("house_id <>", value, "houseId");
            return (Criteria) this;
        }

        public Criteria andHouseIdGreaterThan(Integer value) {
            addCriterion("house_id >", value, "houseId");
            return (Criteria) this;
        }

        public Criteria andHouseIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("house_id >=", value, "houseId");
            return (Criteria) this;
        }

        public Criteria andHouseIdLessThan(Integer value) {
            addCriterion("house_id <", value, "houseId");
            return (Criteria) this;
        }

        public Criteria andHouseIdLessThanOrEqualTo(Integer value) {
            addCriterion("house_id <=", value, "houseId");
            return (Criteria) this;
        }

        public Criteria andHouseIdIn(List<Integer> values) {
            addCriterion("house_id in", values, "houseId");
            return (Criteria) this;
        }

        public Criteria andHouseIdNotIn(List<Integer> values) {
            addCriterion("house_id not in", values, "houseId");
            return (Criteria) this;
        }

        public Criteria andHouseIdBetween(Integer value1, Integer value2) {
            addCriterion("house_id between", value1, value2, "houseId");
            return (Criteria) this;
        }

        public Criteria andHouseIdNotBetween(Integer value1, Integer value2) {
            addCriterion("house_id not between", value1, value2, "houseId");
            return (Criteria) this;
        }

        public Criteria andWarehouseIdIsNull() {
            addCriterion("warehouse_id is null");
            return (Criteria) this;
        }

        public Criteria andWarehouseIdIsNotNull() {
            addCriterion("warehouse_id is not null");
            return (Criteria) this;
        }

        public Criteria andWarehouseIdEqualTo(Integer value) {
            addCriterion("warehouse_id =", value, "warehouseId");
            return (Criteria) this;
        }

        public Criteria andWarehouseIdNotEqualTo(Integer value) {
            addCriterion("warehouse_id <>", value, "warehouseId");
            return (Criteria) this;
        }

        public Criteria andWarehouseIdGreaterThan(Integer value) {
            addCriterion("warehouse_id >", value, "warehouseId");
            return (Criteria) this;
        }

        public Criteria andWarehouseIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("warehouse_id >=", value, "warehouseId");
            return (Criteria) this;
        }

        public Criteria andWarehouseIdLessThan(Integer value) {
            addCriterion("warehouse_id <", value, "warehouseId");
            return (Criteria) this;
        }

        public Criteria andWarehouseIdLessThanOrEqualTo(Integer value) {
            addCriterion("warehouse_id <=", value, "warehouseId");
            return (Criteria) this;
        }

        public Criteria andWarehouseIdIn(List<Integer> values) {
            addCriterion("warehouse_id in", values, "warehouseId");
            return (Criteria) this;
        }

        public Criteria andWarehouseIdNotIn(List<Integer> values) {
            addCriterion("warehouse_id not in", values, "warehouseId");
            return (Criteria) this;
        }

        public Criteria andWarehouseIdBetween(Integer value1, Integer value2) {
            addCriterion("warehouse_id between", value1, value2, "warehouseId");
            return (Criteria) this;
        }

        public Criteria andWarehouseIdNotBetween(Integer value1, Integer value2) {
            addCriterion("warehouse_id not between", value1, value2, "warehouseId");
            return (Criteria) this;
        }

        public Criteria andRecordUniteIsNull() {
            addCriterion("record_unite is null");
            return (Criteria) this;
        }

        public Criteria andRecordUniteIsNotNull() {
            addCriterion("record_unite is not null");
            return (Criteria) this;
        }

        public Criteria andRecordUniteEqualTo(String value) {
            addCriterion("record_unite =", value, "recordUnite");
            return (Criteria) this;
        }

        public Criteria andRecordUniteNotEqualTo(String value) {
            addCriterion("record_unite <>", value, "recordUnite");
            return (Criteria) this;
        }

        public Criteria andRecordUniteGreaterThan(String value) {
            addCriterion("record_unite >", value, "recordUnite");
            return (Criteria) this;
        }

        public Criteria andRecordUniteGreaterThanOrEqualTo(String value) {
            addCriterion("record_unite >=", value, "recordUnite");
            return (Criteria) this;
        }

        public Criteria andRecordUniteLessThan(String value) {
            addCriterion("record_unite <", value, "recordUnite");
            return (Criteria) this;
        }

        public Criteria andRecordUniteLessThanOrEqualTo(String value) {
            addCriterion("record_unite <=", value, "recordUnite");
            return (Criteria) this;
        }

        public Criteria andRecordUniteLike(String value) {
            addCriterion("record_unite like", value, "recordUnite");
            return (Criteria) this;
        }

        public Criteria andRecordUniteNotLike(String value) {
            addCriterion("record_unite not like", value, "recordUnite");
            return (Criteria) this;
        }

        public Criteria andRecordUniteIn(List<String> values) {
            addCriterion("record_unite in", values, "recordUnite");
            return (Criteria) this;
        }

        public Criteria andRecordUniteNotIn(List<String> values) {
            addCriterion("record_unite not in", values, "recordUnite");
            return (Criteria) this;
        }

        public Criteria andRecordUniteBetween(String value1, String value2) {
            addCriterion("record_unite between", value1, value2, "recordUnite");
            return (Criteria) this;
        }

        public Criteria andRecordUniteNotBetween(String value1, String value2) {
            addCriterion("record_unite not between", value1, value2, "recordUnite");
            return (Criteria) this;
        }

        public Criteria andKeepUniteIsNull() {
            addCriterion("keep_unite is null");
            return (Criteria) this;
        }

        public Criteria andKeepUniteIsNotNull() {
            addCriterion("keep_unite is not null");
            return (Criteria) this;
        }

        public Criteria andKeepUniteEqualTo(String value) {
            addCriterion("keep_unite =", value, "keepUnite");
            return (Criteria) this;
        }

        public Criteria andKeepUniteNotEqualTo(String value) {
            addCriterion("keep_unite <>", value, "keepUnite");
            return (Criteria) this;
        }

        public Criteria andKeepUniteGreaterThan(String value) {
            addCriterion("keep_unite >", value, "keepUnite");
            return (Criteria) this;
        }

        public Criteria andKeepUniteGreaterThanOrEqualTo(String value) {
            addCriterion("keep_unite >=", value, "keepUnite");
            return (Criteria) this;
        }

        public Criteria andKeepUniteLessThan(String value) {
            addCriterion("keep_unite <", value, "keepUnite");
            return (Criteria) this;
        }

        public Criteria andKeepUniteLessThanOrEqualTo(String value) {
            addCriterion("keep_unite <=", value, "keepUnite");
            return (Criteria) this;
        }

        public Criteria andKeepUniteLike(String value) {
            addCriterion("keep_unite like", value, "keepUnite");
            return (Criteria) this;
        }

        public Criteria andKeepUniteNotLike(String value) {
            addCriterion("keep_unite not like", value, "keepUnite");
            return (Criteria) this;
        }

        public Criteria andKeepUniteIn(List<String> values) {
            addCriterion("keep_unite in", values, "keepUnite");
            return (Criteria) this;
        }

        public Criteria andKeepUniteNotIn(List<String> values) {
            addCriterion("keep_unite not in", values, "keepUnite");
            return (Criteria) this;
        }

        public Criteria andKeepUniteBetween(String value1, String value2) {
            addCriterion("keep_unite between", value1, value2, "keepUnite");
            return (Criteria) this;
        }

        public Criteria andKeepUniteNotBetween(String value1, String value2) {
            addCriterion("keep_unite not between", value1, value2, "keepUnite");
            return (Criteria) this;
        }

        public Criteria andLocationNumIsNull() {
            addCriterion("location_num is null");
            return (Criteria) this;
        }

        public Criteria andLocationNumIsNotNull() {
            addCriterion("location_num is not null");
            return (Criteria) this;
        }

        public Criteria andLocationNumEqualTo(String value) {
            addCriterion("location_num =", value, "locationNum");
            return (Criteria) this;
        }

        public Criteria andLocationNumNotEqualTo(String value) {
            addCriterion("location_num <>", value, "locationNum");
            return (Criteria) this;
        }

        public Criteria andLocationNumGreaterThan(String value) {
            addCriterion("location_num >", value, "locationNum");
            return (Criteria) this;
        }

        public Criteria andLocationNumGreaterThanOrEqualTo(String value) {
            addCriterion("location_num >=", value, "locationNum");
            return (Criteria) this;
        }

        public Criteria andLocationNumLessThan(String value) {
            addCriterion("location_num <", value, "locationNum");
            return (Criteria) this;
        }

        public Criteria andLocationNumLessThanOrEqualTo(String value) {
            addCriterion("location_num <=", value, "locationNum");
            return (Criteria) this;
        }

        public Criteria andLocationNumLike(String value) {
            addCriterion("location_num like", value, "locationNum");
            return (Criteria) this;
        }

        public Criteria andLocationNumNotLike(String value) {
            addCriterion("location_num not like", value, "locationNum");
            return (Criteria) this;
        }

        public Criteria andLocationNumIn(List<String> values) {
            addCriterion("location_num in", values, "locationNum");
            return (Criteria) this;
        }

        public Criteria andLocationNumNotIn(List<String> values) {
            addCriterion("location_num not in", values, "locationNum");
            return (Criteria) this;
        }

        public Criteria andLocationNumBetween(String value1, String value2) {
            addCriterion("location_num between", value1, value2, "locationNum");
            return (Criteria) this;
        }

        public Criteria andLocationNumNotBetween(String value1, String value2) {
            addCriterion("location_num not between", value1, value2, "locationNum");
            return (Criteria) this;
        }

        public Criteria andQualityIsNull() {
            addCriterion("quality is null");
            return (Criteria) this;
        }

        public Criteria andQualityIsNotNull() {
            addCriterion("quality is not null");
            return (Criteria) this;
        }

        public Criteria andQualityEqualTo(String value) {
            addCriterion("quality =", value, "quality");
            return (Criteria) this;
        }

        public Criteria andQualityNotEqualTo(String value) {
            addCriterion("quality <>", value, "quality");
            return (Criteria) this;
        }

        public Criteria andQualityGreaterThan(String value) {
            addCriterion("quality >", value, "quality");
            return (Criteria) this;
        }

        public Criteria andQualityGreaterThanOrEqualTo(String value) {
            addCriterion("quality >=", value, "quality");
            return (Criteria) this;
        }

        public Criteria andQualityLessThan(String value) {
            addCriterion("quality <", value, "quality");
            return (Criteria) this;
        }

        public Criteria andQualityLessThanOrEqualTo(String value) {
            addCriterion("quality <=", value, "quality");
            return (Criteria) this;
        }

        public Criteria andQualityLike(String value) {
            addCriterion("quality like", value, "quality");
            return (Criteria) this;
        }

        public Criteria andQualityNotLike(String value) {
            addCriterion("quality not like", value, "quality");
            return (Criteria) this;
        }

        public Criteria andQualityIn(List<String> values) {
            addCriterion("quality in", values, "quality");
            return (Criteria) this;
        }

        public Criteria andQualityNotIn(List<String> values) {
            addCriterion("quality not in", values, "quality");
            return (Criteria) this;
        }

        public Criteria andQualityBetween(String value1, String value2) {
            addCriterion("quality between", value1, value2, "quality");
            return (Criteria) this;
        }

        public Criteria andQualityNotBetween(String value1, String value2) {
            addCriterion("quality not between", value1, value2, "quality");
            return (Criteria) this;
        }

        public Criteria andSubTypeIsNull() {
            addCriterion("sub_type is null");
            return (Criteria) this;
        }

        public Criteria andSubTypeIsNotNull() {
            addCriterion("sub_type is not null");
            return (Criteria) this;
        }

        public Criteria andSubTypeEqualTo(Integer value) {
            addCriterion("sub_type =", value, "subType");
            return (Criteria) this;
        }

        public Criteria andSubTypeNotEqualTo(Integer value) {
            addCriterion("sub_type <>", value, "subType");
            return (Criteria) this;
        }

        public Criteria andSubTypeGreaterThan(Integer value) {
            addCriterion("sub_type >", value, "subType");
            return (Criteria) this;
        }

        public Criteria andSubTypeGreaterThanOrEqualTo(Integer value) {
            addCriterion("sub_type >=", value, "subType");
            return (Criteria) this;
        }

        public Criteria andSubTypeLessThan(Integer value) {
            addCriterion("sub_type <", value, "subType");
            return (Criteria) this;
        }

        public Criteria andSubTypeLessThanOrEqualTo(Integer value) {
            addCriterion("sub_type <=", value, "subType");
            return (Criteria) this;
        }

        public Criteria andSubTypeIn(List<Integer> values) {
            addCriterion("sub_type in", values, "subType");
            return (Criteria) this;
        }

        public Criteria andSubTypeNotIn(List<Integer> values) {
            addCriterion("sub_type not in", values, "subType");
            return (Criteria) this;
        }

        public Criteria andSubTypeBetween(Integer value1, Integer value2) {
            addCriterion("sub_type between", value1, value2, "subType");
            return (Criteria) this;
        }

        public Criteria andSubTypeNotBetween(Integer value1, Integer value2) {
            addCriterion("sub_type not between", value1, value2, "subType");
            return (Criteria) this;
        }

        public Criteria andSubTypeDetailedIsNull() {
            addCriterion("sub_type_detailed is null");
            return (Criteria) this;
        }

        public Criteria andSubTypeDetailedIsNotNull() {
            addCriterion("sub_type_detailed is not null");
            return (Criteria) this;
        }

        public Criteria andSubTypeDetailedEqualTo(Integer value) {
            addCriterion("sub_type_detailed =", value, "subTypeDetailed");
            return (Criteria) this;
        }

        public Criteria andSubTypeDetailedNotEqualTo(Integer value) {
            addCriterion("sub_type_detailed <>", value, "subTypeDetailed");
            return (Criteria) this;
        }

        public Criteria andSubTypeDetailedGreaterThan(Integer value) {
            addCriterion("sub_type_detailed >", value, "subTypeDetailed");
            return (Criteria) this;
        }

        public Criteria andSubTypeDetailedGreaterThanOrEqualTo(Integer value) {
            addCriterion("sub_type_detailed >=", value, "subTypeDetailed");
            return (Criteria) this;
        }

        public Criteria andSubTypeDetailedLessThan(Integer value) {
            addCriterion("sub_type_detailed <", value, "subTypeDetailed");
            return (Criteria) this;
        }

        public Criteria andSubTypeDetailedLessThanOrEqualTo(Integer value) {
            addCriterion("sub_type_detailed <=", value, "subTypeDetailed");
            return (Criteria) this;
        }

        public Criteria andSubTypeDetailedIn(List<Integer> values) {
            addCriterion("sub_type_detailed in", values, "subTypeDetailed");
            return (Criteria) this;
        }

        public Criteria andSubTypeDetailedNotIn(List<Integer> values) {
            addCriterion("sub_type_detailed not in", values, "subTypeDetailed");
            return (Criteria) this;
        }

        public Criteria andSubTypeDetailedBetween(Integer value1, Integer value2) {
            addCriterion("sub_type_detailed between", value1, value2, "subTypeDetailed");
            return (Criteria) this;
        }

        public Criteria andSubTypeDetailedNotBetween(Integer value1, Integer value2) {
            addCriterion("sub_type_detailed not between", value1, value2, "subTypeDetailed");
            return (Criteria) this;
        }

        public Criteria andHtypeIsNull() {
            addCriterion("htype is null");
            return (Criteria) this;
        }

        public Criteria andHtypeIsNotNull() {
            addCriterion("htype is not null");
            return (Criteria) this;
        }

        public Criteria andHtypeEqualTo(String value) {
            addCriterion("htype =", value, "htype");
            return (Criteria) this;
        }

        public Criteria andHtypeNotEqualTo(String value) {
            addCriterion("htype <>", value, "htype");
            return (Criteria) this;
        }

        public Criteria andHtypeGreaterThan(String value) {
            addCriterion("htype >", value, "htype");
            return (Criteria) this;
        }

        public Criteria andHtypeGreaterThanOrEqualTo(String value) {
            addCriterion("htype >=", value, "htype");
            return (Criteria) this;
        }

        public Criteria andHtypeLessThan(String value) {
            addCriterion("htype <", value, "htype");
            return (Criteria) this;
        }

        public Criteria andHtypeLessThanOrEqualTo(String value) {
            addCriterion("htype <=", value, "htype");
            return (Criteria) this;
        }

        public Criteria andHtypeLike(String value) {
            addCriterion("htype like", value, "htype");
            return (Criteria) this;
        }

        public Criteria andHtypeNotLike(String value) {
            addCriterion("htype not like", value, "htype");
            return (Criteria) this;
        }

        public Criteria andHtypeIn(List<String> values) {
            addCriterion("htype in", values, "htype");
            return (Criteria) this;
        }

        public Criteria andHtypeNotIn(List<String> values) {
            addCriterion("htype not in", values, "htype");
            return (Criteria) this;
        }

        public Criteria andHtypeBetween(String value1, String value2) {
            addCriterion("htype between", value1, value2, "htype");
            return (Criteria) this;
        }

        public Criteria andHtypeNotBetween(String value1, String value2) {
            addCriterion("htype not between", value1, value2, "htype");
            return (Criteria) this;
        }

        public Criteria andNumberIsNull() {
            addCriterion("number is null");
            return (Criteria) this;
        }

        public Criteria andNumberIsNotNull() {
            addCriterion("number is not null");
            return (Criteria) this;
        }

        public Criteria andNumberEqualTo(Double value) {
            addCriterion("number =", value, "number");
            return (Criteria) this;
        }

        public Criteria andNumberNotEqualTo(Double value) {
            addCriterion("number <>", value, "number");
            return (Criteria) this;
        }

        public Criteria andNumberGreaterThan(Double value) {
            addCriterion("number >", value, "number");
            return (Criteria) this;
        }

        public Criteria andNumberGreaterThanOrEqualTo(Double value) {
            addCriterion("number >=", value, "number");
            return (Criteria) this;
        }

        public Criteria andNumberLessThan(Double value) {
            addCriterion("number <", value, "number");
            return (Criteria) this;
        }

        public Criteria andNumberLessThanOrEqualTo(Double value) {
            addCriterion("number <=", value, "number");
            return (Criteria) this;
        }

        public Criteria andNumberIn(List<Double> values) {
            addCriterion("number in", values, "number");
            return (Criteria) this;
        }

        public Criteria andNumberNotIn(List<Double> values) {
            addCriterion("number not in", values, "number");
            return (Criteria) this;
        }

        public Criteria andNumberBetween(Double value1, Double value2) {
            addCriterion("number between", value1, value2, "number");
            return (Criteria) this;
        }

        public Criteria andNumberNotBetween(Double value1, Double value2) {
            addCriterion("number not between", value1, value2, "number");
            return (Criteria) this;
        }

        public Criteria andStandNumberIsNull() {
            addCriterion("stand_number is null");
            return (Criteria) this;
        }

        public Criteria andStandNumberIsNotNull() {
            addCriterion("stand_number is not null");
            return (Criteria) this;
        }

        public Criteria andStandNumberEqualTo(Double value) {
            addCriterion("stand_number =", value, "standNumber");
            return (Criteria) this;
        }

        public Criteria andStandNumberNotEqualTo(Double value) {
            addCriterion("stand_number <>", value, "standNumber");
            return (Criteria) this;
        }

        public Criteria andStandNumberGreaterThan(Double value) {
            addCriterion("stand_number >", value, "standNumber");
            return (Criteria) this;
        }

        public Criteria andStandNumberGreaterThanOrEqualTo(Double value) {
            addCriterion("stand_number >=", value, "standNumber");
            return (Criteria) this;
        }

        public Criteria andStandNumberLessThan(Double value) {
            addCriterion("stand_number <", value, "standNumber");
            return (Criteria) this;
        }

        public Criteria andStandNumberLessThanOrEqualTo(Double value) {
            addCriterion("stand_number <=", value, "standNumber");
            return (Criteria) this;
        }

        public Criteria andStandNumberIn(List<Double> values) {
            addCriterion("stand_number in", values, "standNumber");
            return (Criteria) this;
        }

        public Criteria andStandNumberNotIn(List<Double> values) {
            addCriterion("stand_number not in", values, "standNumber");
            return (Criteria) this;
        }

        public Criteria andStandNumberBetween(Double value1, Double value2) {
            addCriterion("stand_number between", value1, value2, "standNumber");
            return (Criteria) this;
        }

        public Criteria andStandNumberNotBetween(Double value1, Double value2) {
            addCriterion("stand_number not between", value1, value2, "standNumber");
            return (Criteria) this;
        }

        public Criteria andInputYearIsNull() {
            addCriterion("input_year is null");
            return (Criteria) this;
        }

        public Criteria andInputYearIsNotNull() {
            addCriterion("input_year is not null");
            return (Criteria) this;
        }

        public Criteria andInputYearEqualTo(Date value) {
            addCriterion("input_year =", value, "inputYear");
            return (Criteria) this;
        }

        public Criteria andInputYearNotEqualTo(Date value) {
            addCriterion("input_year <>", value, "inputYear");
            return (Criteria) this;
        }

        public Criteria andInputYearGreaterThan(Date value) {
            addCriterion("input_year >", value, "inputYear");
            return (Criteria) this;
        }

        public Criteria andInputYearGreaterThanOrEqualTo(Date value) {
            addCriterion("input_year >=", value, "inputYear");
            return (Criteria) this;
        }

        public Criteria andInputYearLessThan(Date value) {
            addCriterion("input_year <", value, "inputYear");
            return (Criteria) this;
        }

        public Criteria andInputYearLessThanOrEqualTo(Date value) {
            addCriterion("input_year <=", value, "inputYear");
            return (Criteria) this;
        }

        public Criteria andInputYearIn(List<Date> values) {
            addCriterion("input_year in", values, "inputYear");
            return (Criteria) this;
        }

        public Criteria andInputYearNotIn(List<Date> values) {
            addCriterion("input_year not in", values, "inputYear");
            return (Criteria) this;
        }

        public Criteria andInputYearBetween(Date value1, Date value2) {
            addCriterion("input_year between", value1, value2, "inputYear");
            return (Criteria) this;
        }

        public Criteria andInputYearNotBetween(Date value1, Date value2) {
            addCriterion("input_year not between", value1, value2, "inputYear");
            return (Criteria) this;
        }

        public Criteria andGrowYearIsNull() {
            addCriterion("grow_year is null");
            return (Criteria) this;
        }

        public Criteria andGrowYearIsNotNull() {
            addCriterion("grow_year is not null");
            return (Criteria) this;
        }

        public Criteria andGrowYearEqualTo(Integer value) {
            addCriterion("grow_year =", value, "growYear");
            return (Criteria) this;
        }

        public Criteria andGrowYearNotEqualTo(Integer value) {
            addCriterion("grow_year <>", value, "growYear");
            return (Criteria) this;
        }

        public Criteria andGrowYearGreaterThan(Integer value) {
            addCriterion("grow_year >", value, "growYear");
            return (Criteria) this;
        }

        public Criteria andGrowYearGreaterThanOrEqualTo(Integer value) {
            addCriterion("grow_year >=", value, "growYear");
            return (Criteria) this;
        }

        public Criteria andGrowYearLessThan(Integer value) {
            addCriterion("grow_year <", value, "growYear");
            return (Criteria) this;
        }

        public Criteria andGrowYearLessThanOrEqualTo(Integer value) {
            addCriterion("grow_year <=", value, "growYear");
            return (Criteria) this;
        }

        public Criteria andGrowYearIn(List<Integer> values) {
            addCriterion("grow_year in", values, "growYear");
            return (Criteria) this;
        }

        public Criteria andGrowYearNotIn(List<Integer> values) {
            addCriterion("grow_year not in", values, "growYear");
            return (Criteria) this;
        }

        public Criteria andGrowYearBetween(Integer value1, Integer value2) {
            addCriterion("grow_year between", value1, value2, "growYear");
            return (Criteria) this;
        }

        public Criteria andGrowYearNotBetween(Integer value1, Integer value2) {
            addCriterion("grow_year not between", value1, value2, "growYear");
            return (Criteria) this;
        }

        public Criteria andKeepMethodIsNull() {
            addCriterion("keep_method is null");
            return (Criteria) this;
        }

        public Criteria andKeepMethodIsNotNull() {
            addCriterion("keep_method is not null");
            return (Criteria) this;
        }

        public Criteria andKeepMethodEqualTo(String value) {
            addCriterion("keep_method =", value, "keepMethod");
            return (Criteria) this;
        }

        public Criteria andKeepMethodNotEqualTo(String value) {
            addCriterion("keep_method <>", value, "keepMethod");
            return (Criteria) this;
        }

        public Criteria andKeepMethodGreaterThan(String value) {
            addCriterion("keep_method >", value, "keepMethod");
            return (Criteria) this;
        }

        public Criteria andKeepMethodGreaterThanOrEqualTo(String value) {
            addCriterion("keep_method >=", value, "keepMethod");
            return (Criteria) this;
        }

        public Criteria andKeepMethodLessThan(String value) {
            addCriterion("keep_method <", value, "keepMethod");
            return (Criteria) this;
        }

        public Criteria andKeepMethodLessThanOrEqualTo(String value) {
            addCriterion("keep_method <=", value, "keepMethod");
            return (Criteria) this;
        }

        public Criteria andKeepMethodLike(String value) {
            addCriterion("keep_method like", value, "keepMethod");
            return (Criteria) this;
        }

        public Criteria andKeepMethodNotLike(String value) {
            addCriterion("keep_method not like", value, "keepMethod");
            return (Criteria) this;
        }

        public Criteria andKeepMethodIn(List<String> values) {
            addCriterion("keep_method in", values, "keepMethod");
            return (Criteria) this;
        }

        public Criteria andKeepMethodNotIn(List<String> values) {
            addCriterion("keep_method not in", values, "keepMethod");
            return (Criteria) this;
        }

        public Criteria andKeepMethodBetween(String value1, String value2) {
            addCriterion("keep_method between", value1, value2, "keepMethod");
            return (Criteria) this;
        }

        public Criteria andKeepMethodNotBetween(String value1, String value2) {
            addCriterion("keep_method not between", value1, value2, "keepMethod");
            return (Criteria) this;
        }

        public Criteria andLevelIsNull() {
            addCriterion("level is null");
            return (Criteria) this;
        }

        public Criteria andLevelIsNotNull() {
            addCriterion("level is not null");
            return (Criteria) this;
        }

        public Criteria andLevelEqualTo(String value) {
            addCriterion("level =", value, "level");
            return (Criteria) this;
        }

        public Criteria andLevelNotEqualTo(String value) {
            addCriterion("level <>", value, "level");
            return (Criteria) this;
        }

        public Criteria andLevelGreaterThan(String value) {
            addCriterion("level >", value, "level");
            return (Criteria) this;
        }

        public Criteria andLevelGreaterThanOrEqualTo(String value) {
            addCriterion("level >=", value, "level");
            return (Criteria) this;
        }

        public Criteria andLevelLessThan(String value) {
            addCriterion("level <", value, "level");
            return (Criteria) this;
        }

        public Criteria andLevelLessThanOrEqualTo(String value) {
            addCriterion("level <=", value, "level");
            return (Criteria) this;
        }

        public Criteria andLevelLike(String value) {
            addCriterion("level like", value, "level");
            return (Criteria) this;
        }

        public Criteria andLevelNotLike(String value) {
            addCriterion("level not like", value, "level");
            return (Criteria) this;
        }

        public Criteria andLevelIn(List<String> values) {
            addCriterion("level in", values, "level");
            return (Criteria) this;
        }

        public Criteria andLevelNotIn(List<String> values) {
            addCriterion("level not in", values, "level");
            return (Criteria) this;
        }

        public Criteria andLevelBetween(String value1, String value2) {
            addCriterion("level between", value1, value2, "level");
            return (Criteria) this;
        }

        public Criteria andLevelNotBetween(String value1, String value2) {
            addCriterion("level not between", value1, value2, "level");
            return (Criteria) this;
        }

        public Criteria andWeightIsNull() {
            addCriterion("weight is null");
            return (Criteria) this;
        }

        public Criteria andWeightIsNotNull() {
            addCriterion("weight is not null");
            return (Criteria) this;
        }

        public Criteria andWeightEqualTo(String value) {
            addCriterion("weight =", value, "weight");
            return (Criteria) this;
        }

        public Criteria andWeightNotEqualTo(String value) {
            addCriterion("weight <>", value, "weight");
            return (Criteria) this;
        }

        public Criteria andWeightGreaterThan(String value) {
            addCriterion("weight >", value, "weight");
            return (Criteria) this;
        }

        public Criteria andWeightGreaterThanOrEqualTo(String value) {
            addCriterion("weight >=", value, "weight");
            return (Criteria) this;
        }

        public Criteria andWeightLessThan(String value) {
            addCriterion("weight <", value, "weight");
            return (Criteria) this;
        }

        public Criteria andWeightLessThanOrEqualTo(String value) {
            addCriterion("weight <=", value, "weight");
            return (Criteria) this;
        }

        public Criteria andWeightLike(String value) {
            addCriterion("weight like", value, "weight");
            return (Criteria) this;
        }

        public Criteria andWeightNotLike(String value) {
            addCriterion("weight not like", value, "weight");
            return (Criteria) this;
        }

        public Criteria andWeightIn(List<String> values) {
            addCriterion("weight in", values, "weight");
            return (Criteria) this;
        }

        public Criteria andWeightNotIn(List<String> values) {
            addCriterion("weight not in", values, "weight");
            return (Criteria) this;
        }

        public Criteria andWeightBetween(String value1, String value2) {
            addCriterion("weight between", value1, value2, "weight");
            return (Criteria) this;
        }

        public Criteria andWeightNotBetween(String value1, String value2) {
            addCriterion("weight not between", value1, value2, "weight");
            return (Criteria) this;
        }

        public Criteria andImpurityIsNull() {
            addCriterion("impurity is null");
            return (Criteria) this;
        }

        public Criteria andImpurityIsNotNull() {
            addCriterion("impurity is not null");
            return (Criteria) this;
        }

        public Criteria andImpurityEqualTo(String value) {
            addCriterion("impurity =", value, "impurity");
            return (Criteria) this;
        }

        public Criteria andImpurityNotEqualTo(String value) {
            addCriterion("impurity <>", value, "impurity");
            return (Criteria) this;
        }

        public Criteria andImpurityGreaterThan(String value) {
            addCriterion("impurity >", value, "impurity");
            return (Criteria) this;
        }

        public Criteria andImpurityGreaterThanOrEqualTo(String value) {
            addCriterion("impurity >=", value, "impurity");
            return (Criteria) this;
        }

        public Criteria andImpurityLessThan(String value) {
            addCriterion("impurity <", value, "impurity");
            return (Criteria) this;
        }

        public Criteria andImpurityLessThanOrEqualTo(String value) {
            addCriterion("impurity <=", value, "impurity");
            return (Criteria) this;
        }

        public Criteria andImpurityLike(String value) {
            addCriterion("impurity like", value, "impurity");
            return (Criteria) this;
        }

        public Criteria andImpurityNotLike(String value) {
            addCriterion("impurity not like", value, "impurity");
            return (Criteria) this;
        }

        public Criteria andImpurityIn(List<String> values) {
            addCriterion("impurity in", values, "impurity");
            return (Criteria) this;
        }

        public Criteria andImpurityNotIn(List<String> values) {
            addCriterion("impurity not in", values, "impurity");
            return (Criteria) this;
        }

        public Criteria andImpurityBetween(String value1, String value2) {
            addCriterion("impurity between", value1, value2, "impurity");
            return (Criteria) this;
        }

        public Criteria andImpurityNotBetween(String value1, String value2) {
            addCriterion("impurity not between", value1, value2, "impurity");
            return (Criteria) this;
        }

        public Criteria andWaterIsNull() {
            addCriterion("water is null");
            return (Criteria) this;
        }

        public Criteria andWaterIsNotNull() {
            addCriterion("water is not null");
            return (Criteria) this;
        }

        public Criteria andWaterEqualTo(String value) {
            addCriterion("water =", value, "water");
            return (Criteria) this;
        }

        public Criteria andWaterNotEqualTo(String value) {
            addCriterion("water <>", value, "water");
            return (Criteria) this;
        }

        public Criteria andWaterGreaterThan(String value) {
            addCriterion("water >", value, "water");
            return (Criteria) this;
        }

        public Criteria andWaterGreaterThanOrEqualTo(String value) {
            addCriterion("water >=", value, "water");
            return (Criteria) this;
        }

        public Criteria andWaterLessThan(String value) {
            addCriterion("water <", value, "water");
            return (Criteria) this;
        }

        public Criteria andWaterLessThanOrEqualTo(String value) {
            addCriterion("water <=", value, "water");
            return (Criteria) this;
        }

        public Criteria andWaterLike(String value) {
            addCriterion("water like", value, "water");
            return (Criteria) this;
        }

        public Criteria andWaterNotLike(String value) {
            addCriterion("water not like", value, "water");
            return (Criteria) this;
        }

        public Criteria andWaterIn(List<String> values) {
            addCriterion("water in", values, "water");
            return (Criteria) this;
        }

        public Criteria andWaterNotIn(List<String> values) {
            addCriterion("water not in", values, "water");
            return (Criteria) this;
        }

        public Criteria andWaterBetween(String value1, String value2) {
            addCriterion("water between", value1, value2, "water");
            return (Criteria) this;
        }

        public Criteria andWaterNotBetween(String value1, String value2) {
            addCriterion("water not between", value1, value2, "water");
            return (Criteria) this;
        }

        public Criteria andUnsoundIsNull() {
            addCriterion("unsound is null");
            return (Criteria) this;
        }

        public Criteria andUnsoundIsNotNull() {
            addCriterion("unsound is not null");
            return (Criteria) this;
        }

        public Criteria andUnsoundEqualTo(String value) {
            addCriterion("unsound =", value, "unsound");
            return (Criteria) this;
        }

        public Criteria andUnsoundNotEqualTo(String value) {
            addCriterion("unsound <>", value, "unsound");
            return (Criteria) this;
        }

        public Criteria andUnsoundGreaterThan(String value) {
            addCriterion("unsound >", value, "unsound");
            return (Criteria) this;
        }

        public Criteria andUnsoundGreaterThanOrEqualTo(String value) {
            addCriterion("unsound >=", value, "unsound");
            return (Criteria) this;
        }

        public Criteria andUnsoundLessThan(String value) {
            addCriterion("unsound <", value, "unsound");
            return (Criteria) this;
        }

        public Criteria andUnsoundLessThanOrEqualTo(String value) {
            addCriterion("unsound <=", value, "unsound");
            return (Criteria) this;
        }

        public Criteria andUnsoundLike(String value) {
            addCriterion("unsound like", value, "unsound");
            return (Criteria) this;
        }

        public Criteria andUnsoundNotLike(String value) {
            addCriterion("unsound not like", value, "unsound");
            return (Criteria) this;
        }

        public Criteria andUnsoundIn(List<String> values) {
            addCriterion("unsound in", values, "unsound");
            return (Criteria) this;
        }

        public Criteria andUnsoundNotIn(List<String> values) {
            addCriterion("unsound not in", values, "unsound");
            return (Criteria) this;
        }

        public Criteria andUnsoundBetween(String value1, String value2) {
            addCriterion("unsound between", value1, value2, "unsound");
            return (Criteria) this;
        }

        public Criteria andUnsoundNotBetween(String value1, String value2) {
            addCriterion("unsound not between", value1, value2, "unsound");
            return (Criteria) this;
        }

        public Criteria andRecorderIsNull() {
            addCriterion("recorder is null");
            return (Criteria) this;
        }

        public Criteria andRecorderIsNotNull() {
            addCriterion("recorder is not null");
            return (Criteria) this;
        }

        public Criteria andRecorderEqualTo(String value) {
            addCriterion("recorder =", value, "recorder");
            return (Criteria) this;
        }

        public Criteria andRecorderNotEqualTo(String value) {
            addCriterion("recorder <>", value, "recorder");
            return (Criteria) this;
        }

        public Criteria andRecorderGreaterThan(String value) {
            addCriterion("recorder >", value, "recorder");
            return (Criteria) this;
        }

        public Criteria andRecorderGreaterThanOrEqualTo(String value) {
            addCriterion("recorder >=", value, "recorder");
            return (Criteria) this;
        }

        public Criteria andRecorderLessThan(String value) {
            addCriterion("recorder <", value, "recorder");
            return (Criteria) this;
        }

        public Criteria andRecorderLessThanOrEqualTo(String value) {
            addCriterion("recorder <=", value, "recorder");
            return (Criteria) this;
        }

        public Criteria andRecorderLike(String value) {
            addCriterion("recorder like", value, "recorder");
            return (Criteria) this;
        }

        public Criteria andRecorderNotLike(String value) {
            addCriterion("recorder not like", value, "recorder");
            return (Criteria) this;
        }

        public Criteria andRecorderIn(List<String> values) {
            addCriterion("recorder in", values, "recorder");
            return (Criteria) this;
        }

        public Criteria andRecorderNotIn(List<String> values) {
            addCriterion("recorder not in", values, "recorder");
            return (Criteria) this;
        }

        public Criteria andRecorderBetween(String value1, String value2) {
            addCriterion("recorder between", value1, value2, "recorder");
            return (Criteria) this;
        }

        public Criteria andRecorderNotBetween(String value1, String value2) {
            addCriterion("recorder not between", value1, value2, "recorder");
            return (Criteria) this;
        }

        public Criteria andHouseTypeIsNull() {
            addCriterion("house_type is null");
            return (Criteria) this;
        }

        public Criteria andHouseTypeIsNotNull() {
            addCriterion("house_type is not null");
            return (Criteria) this;
        }

        public Criteria andHouseTypeEqualTo(String value) {
            addCriterion("house_type =", value, "houseType");
            return (Criteria) this;
        }

        public Criteria andHouseTypeNotEqualTo(String value) {
            addCriterion("house_type <>", value, "houseType");
            return (Criteria) this;
        }

        public Criteria andHouseTypeGreaterThan(String value) {
            addCriterion("house_type >", value, "houseType");
            return (Criteria) this;
        }

        public Criteria andHouseTypeGreaterThanOrEqualTo(String value) {
            addCriterion("house_type >=", value, "houseType");
            return (Criteria) this;
        }

        public Criteria andHouseTypeLessThan(String value) {
            addCriterion("house_type <", value, "houseType");
            return (Criteria) this;
        }

        public Criteria andHouseTypeLessThanOrEqualTo(String value) {
            addCriterion("house_type <=", value, "houseType");
            return (Criteria) this;
        }

        public Criteria andHouseTypeLike(String value) {
            addCriterion("house_type like", value, "houseType");
            return (Criteria) this;
        }

        public Criteria andHouseTypeNotLike(String value) {
            addCriterion("house_type not like", value, "houseType");
            return (Criteria) this;
        }

        public Criteria andHouseTypeIn(List<String> values) {
            addCriterion("house_type in", values, "houseType");
            return (Criteria) this;
        }

        public Criteria andHouseTypeNotIn(List<String> values) {
            addCriterion("house_type not in", values, "houseType");
            return (Criteria) this;
        }

        public Criteria andHouseTypeBetween(String value1, String value2) {
            addCriterion("house_type between", value1, value2, "houseType");
            return (Criteria) this;
        }

        public Criteria andHouseTypeNotBetween(String value1, String value2) {
            addCriterion("house_type not between", value1, value2, "houseType");
            return (Criteria) this;
        }

        public Criteria andDesignHouseCapacityIsNull() {
            addCriterion("design_house_capacity is null");
            return (Criteria) this;
        }

        public Criteria andDesignHouseCapacityIsNotNull() {
            addCriterion("design_house_capacity is not null");
            return (Criteria) this;
        }

        public Criteria andDesignHouseCapacityEqualTo(BigDecimal value) {
            addCriterion("design_house_capacity =", value, "designHouseCapacity");
            return (Criteria) this;
        }

        public Criteria andDesignHouseCapacityNotEqualTo(BigDecimal value) {
            addCriterion("design_house_capacity <>", value, "designHouseCapacity");
            return (Criteria) this;
        }

        public Criteria andDesignHouseCapacityGreaterThan(BigDecimal value) {
            addCriterion("design_house_capacity >", value, "designHouseCapacity");
            return (Criteria) this;
        }

        public Criteria andDesignHouseCapacityGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("design_house_capacity >=", value, "designHouseCapacity");
            return (Criteria) this;
        }

        public Criteria andDesignHouseCapacityLessThan(BigDecimal value) {
            addCriterion("design_house_capacity <", value, "designHouseCapacity");
            return (Criteria) this;
        }

        public Criteria andDesignHouseCapacityLessThanOrEqualTo(BigDecimal value) {
            addCriterion("design_house_capacity <=", value, "designHouseCapacity");
            return (Criteria) this;
        }

        public Criteria andDesignHouseCapacityIn(List<BigDecimal> values) {
            addCriterion("design_house_capacity in", values, "designHouseCapacity");
            return (Criteria) this;
        }

        public Criteria andDesignHouseCapacityNotIn(List<BigDecimal> values) {
            addCriterion("design_house_capacity not in", values, "designHouseCapacity");
            return (Criteria) this;
        }

        public Criteria andDesignHouseCapacityBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("design_house_capacity between", value1, value2, "designHouseCapacity");
            return (Criteria) this;
        }

        public Criteria andDesignHouseCapacityNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("design_house_capacity not between", value1, value2, "designHouseCapacity");
            return (Criteria) this;
        }

        public Criteria andValidHouseCapacityIsNull() {
            addCriterion("valid_house_capacity is null");
            return (Criteria) this;
        }

        public Criteria andValidHouseCapacityIsNotNull() {
            addCriterion("valid_house_capacity is not null");
            return (Criteria) this;
        }

        public Criteria andValidHouseCapacityEqualTo(String value) {
            addCriterion("valid_house_capacity =", value, "validHouseCapacity");
            return (Criteria) this;
        }

        public Criteria andValidHouseCapacityNotEqualTo(String value) {
            addCriterion("valid_house_capacity <>", value, "validHouseCapacity");
            return (Criteria) this;
        }

        public Criteria andValidHouseCapacityGreaterThan(String value) {
            addCriterion("valid_house_capacity >", value, "validHouseCapacity");
            return (Criteria) this;
        }

        public Criteria andValidHouseCapacityGreaterThanOrEqualTo(String value) {
            addCriterion("valid_house_capacity >=", value, "validHouseCapacity");
            return (Criteria) this;
        }

        public Criteria andValidHouseCapacityLessThan(String value) {
            addCriterion("valid_house_capacity <", value, "validHouseCapacity");
            return (Criteria) this;
        }

        public Criteria andValidHouseCapacityLessThanOrEqualTo(String value) {
            addCriterion("valid_house_capacity <=", value, "validHouseCapacity");
            return (Criteria) this;
        }

        public Criteria andValidHouseCapacityLike(String value) {
            addCriterion("valid_house_capacity like", value, "validHouseCapacity");
            return (Criteria) this;
        }

        public Criteria andValidHouseCapacityNotLike(String value) {
            addCriterion("valid_house_capacity not like", value, "validHouseCapacity");
            return (Criteria) this;
        }

        public Criteria andValidHouseCapacityIn(List<String> values) {
            addCriterion("valid_house_capacity in", values, "validHouseCapacity");
            return (Criteria) this;
        }

        public Criteria andValidHouseCapacityNotIn(List<String> values) {
            addCriterion("valid_house_capacity not in", values, "validHouseCapacity");
            return (Criteria) this;
        }

        public Criteria andValidHouseCapacityBetween(String value1, String value2) {
            addCriterion("valid_house_capacity between", value1, value2, "validHouseCapacity");
            return (Criteria) this;
        }

        public Criteria andValidHouseCapacityNotBetween(String value1, String value2) {
            addCriterion("valid_house_capacity not between", value1, value2, "validHouseCapacity");
            return (Criteria) this;
        }

        public Criteria andPriceIsNull() {
            addCriterion("price is null");
            return (Criteria) this;
        }

        public Criteria andPriceIsNotNull() {
            addCriterion("price is not null");
            return (Criteria) this;
        }

        public Criteria andPriceEqualTo(String value) {
            addCriterion("price =", value, "price");
            return (Criteria) this;
        }

        public Criteria andPriceNotEqualTo(String value) {
            addCriterion("price <>", value, "price");
            return (Criteria) this;
        }

        public Criteria andPriceGreaterThan(String value) {
            addCriterion("price >", value, "price");
            return (Criteria) this;
        }

        public Criteria andPriceGreaterThanOrEqualTo(String value) {
            addCriterion("price >=", value, "price");
            return (Criteria) this;
        }

        public Criteria andPriceLessThan(String value) {
            addCriterion("price <", value, "price");
            return (Criteria) this;
        }

        public Criteria andPriceLessThanOrEqualTo(String value) {
            addCriterion("price <=", value, "price");
            return (Criteria) this;
        }

        public Criteria andPriceLike(String value) {
            addCriterion("price like", value, "price");
            return (Criteria) this;
        }

        public Criteria andPriceNotLike(String value) {
            addCriterion("price not like", value, "price");
            return (Criteria) this;
        }

        public Criteria andPriceIn(List<String> values) {
            addCriterion("price in", values, "price");
            return (Criteria) this;
        }

        public Criteria andPriceNotIn(List<String> values) {
            addCriterion("price not in", values, "price");
            return (Criteria) this;
        }

        public Criteria andPriceBetween(String value1, String value2) {
            addCriterion("price between", value1, value2, "price");
            return (Criteria) this;
        }

        public Criteria andPriceNotBetween(String value1, String value2) {
            addCriterion("price not between", value1, value2, "price");
            return (Criteria) this;
        }

        public Criteria andPlaceOfOriginIsNull() {
            addCriterion("place_of_origin is null");
            return (Criteria) this;
        }

        public Criteria andPlaceOfOriginIsNotNull() {
            addCriterion("place_of_origin is not null");
            return (Criteria) this;
        }

        public Criteria andPlaceOfOriginEqualTo(String value) {
            addCriterion("place_of_origin =", value, "placeOfOrigin");
            return (Criteria) this;
        }

        public Criteria andPlaceOfOriginNotEqualTo(String value) {
            addCriterion("place_of_origin <>", value, "placeOfOrigin");
            return (Criteria) this;
        }

        public Criteria andPlaceOfOriginGreaterThan(String value) {
            addCriterion("place_of_origin >", value, "placeOfOrigin");
            return (Criteria) this;
        }

        public Criteria andPlaceOfOriginGreaterThanOrEqualTo(String value) {
            addCriterion("place_of_origin >=", value, "placeOfOrigin");
            return (Criteria) this;
        }

        public Criteria andPlaceOfOriginLessThan(String value) {
            addCriterion("place_of_origin <", value, "placeOfOrigin");
            return (Criteria) this;
        }

        public Criteria andPlaceOfOriginLessThanOrEqualTo(String value) {
            addCriterion("place_of_origin <=", value, "placeOfOrigin");
            return (Criteria) this;
        }

        public Criteria andPlaceOfOriginLike(String value) {
            addCriterion("place_of_origin like", value, "placeOfOrigin");
            return (Criteria) this;
        }

        public Criteria andPlaceOfOriginNotLike(String value) {
            addCriterion("place_of_origin not like", value, "placeOfOrigin");
            return (Criteria) this;
        }

        public Criteria andPlaceOfOriginIn(List<String> values) {
            addCriterion("place_of_origin in", values, "placeOfOrigin");
            return (Criteria) this;
        }

        public Criteria andPlaceOfOriginNotIn(List<String> values) {
            addCriterion("place_of_origin not in", values, "placeOfOrigin");
            return (Criteria) this;
        }

        public Criteria andPlaceOfOriginBetween(String value1, String value2) {
            addCriterion("place_of_origin between", value1, value2, "placeOfOrigin");
            return (Criteria) this;
        }

        public Criteria andPlaceOfOriginNotBetween(String value1, String value2) {
            addCriterion("place_of_origin not between", value1, value2, "placeOfOrigin");
            return (Criteria) this;
        }

        public Criteria andStorageLocationIsNull() {
            addCriterion("storage_location is null");
            return (Criteria) this;
        }

        public Criteria andStorageLocationIsNotNull() {
            addCriterion("storage_location is not null");
            return (Criteria) this;
        }

        public Criteria andStorageLocationEqualTo(String value) {
            addCriterion("storage_location =", value, "storageLocation");
            return (Criteria) this;
        }

        public Criteria andStorageLocationNotEqualTo(String value) {
            addCriterion("storage_location <>", value, "storageLocation");
            return (Criteria) this;
        }

        public Criteria andStorageLocationGreaterThan(String value) {
            addCriterion("storage_location >", value, "storageLocation");
            return (Criteria) this;
        }

        public Criteria andStorageLocationGreaterThanOrEqualTo(String value) {
            addCriterion("storage_location >=", value, "storageLocation");
            return (Criteria) this;
        }

        public Criteria andStorageLocationLessThan(String value) {
            addCriterion("storage_location <", value, "storageLocation");
            return (Criteria) this;
        }

        public Criteria andStorageLocationLessThanOrEqualTo(String value) {
            addCriterion("storage_location <=", value, "storageLocation");
            return (Criteria) this;
        }

        public Criteria andStorageLocationLike(String value) {
            addCriterion("storage_location like", value, "storageLocation");
            return (Criteria) this;
        }

        public Criteria andStorageLocationNotLike(String value) {
            addCriterion("storage_location not like", value, "storageLocation");
            return (Criteria) this;
        }

        public Criteria andStorageLocationIn(List<String> values) {
            addCriterion("storage_location in", values, "storageLocation");
            return (Criteria) this;
        }

        public Criteria andStorageLocationNotIn(List<String> values) {
            addCriterion("storage_location not in", values, "storageLocation");
            return (Criteria) this;
        }

        public Criteria andStorageLocationBetween(String value1, String value2) {
            addCriterion("storage_location between", value1, value2, "storageLocation");
            return (Criteria) this;
        }

        public Criteria andStorageLocationNotBetween(String value1, String value2) {
            addCriterion("storage_location not between", value1, value2, "storageLocation");
            return (Criteria) this;
        }

        public Criteria andDisperseCapacityIsNull() {
            addCriterion("disperse_capacity is null");
            return (Criteria) this;
        }

        public Criteria andDisperseCapacityIsNotNull() {
            addCriterion("disperse_capacity is not null");
            return (Criteria) this;
        }

        public Criteria andDisperseCapacityEqualTo(String value) {
            addCriterion("disperse_capacity =", value, "disperseCapacity");
            return (Criteria) this;
        }

        public Criteria andDisperseCapacityNotEqualTo(String value) {
            addCriterion("disperse_capacity <>", value, "disperseCapacity");
            return (Criteria) this;
        }

        public Criteria andDisperseCapacityGreaterThan(String value) {
            addCriterion("disperse_capacity >", value, "disperseCapacity");
            return (Criteria) this;
        }

        public Criteria andDisperseCapacityGreaterThanOrEqualTo(String value) {
            addCriterion("disperse_capacity >=", value, "disperseCapacity");
            return (Criteria) this;
        }

        public Criteria andDisperseCapacityLessThan(String value) {
            addCriterion("disperse_capacity <", value, "disperseCapacity");
            return (Criteria) this;
        }

        public Criteria andDisperseCapacityLessThanOrEqualTo(String value) {
            addCriterion("disperse_capacity <=", value, "disperseCapacity");
            return (Criteria) this;
        }

        public Criteria andDisperseCapacityLike(String value) {
            addCriterion("disperse_capacity like", value, "disperseCapacity");
            return (Criteria) this;
        }

        public Criteria andDisperseCapacityNotLike(String value) {
            addCriterion("disperse_capacity not like", value, "disperseCapacity");
            return (Criteria) this;
        }

        public Criteria andDisperseCapacityIn(List<String> values) {
            addCriterion("disperse_capacity in", values, "disperseCapacity");
            return (Criteria) this;
        }

        public Criteria andDisperseCapacityNotIn(List<String> values) {
            addCriterion("disperse_capacity not in", values, "disperseCapacity");
            return (Criteria) this;
        }

        public Criteria andDisperseCapacityBetween(String value1, String value2) {
            addCriterion("disperse_capacity between", value1, value2, "disperseCapacity");
            return (Criteria) this;
        }

        public Criteria andDisperseCapacityNotBetween(String value1, String value2) {
            addCriterion("disperse_capacity not between", value1, value2, "disperseCapacity");
            return (Criteria) this;
        }

        public Criteria andLengthIsNull() {
            addCriterion("length is null");
            return (Criteria) this;
        }

        public Criteria andLengthIsNotNull() {
            addCriterion("length is not null");
            return (Criteria) this;
        }

        public Criteria andLengthEqualTo(BigDecimal value) {
            addCriterion("length =", value, "length");
            return (Criteria) this;
        }

        public Criteria andLengthNotEqualTo(BigDecimal value) {
            addCriterion("length <>", value, "length");
            return (Criteria) this;
        }

        public Criteria andLengthGreaterThan(BigDecimal value) {
            addCriterion("length >", value, "length");
            return (Criteria) this;
        }

        public Criteria andLengthGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("length >=", value, "length");
            return (Criteria) this;
        }

        public Criteria andLengthLessThan(BigDecimal value) {
            addCriterion("length <", value, "length");
            return (Criteria) this;
        }

        public Criteria andLengthLessThanOrEqualTo(BigDecimal value) {
            addCriterion("length <=", value, "length");
            return (Criteria) this;
        }

        public Criteria andLengthIn(List<BigDecimal> values) {
            addCriterion("length in", values, "length");
            return (Criteria) this;
        }

        public Criteria andLengthNotIn(List<BigDecimal> values) {
            addCriterion("length not in", values, "length");
            return (Criteria) this;
        }

        public Criteria andLengthBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("length between", value1, value2, "length");
            return (Criteria) this;
        }

        public Criteria andLengthNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("length not between", value1, value2, "length");
            return (Criteria) this;
        }

        public Criteria andWidthIsNull() {
            addCriterion("width is null");
            return (Criteria) this;
        }

        public Criteria andWidthIsNotNull() {
            addCriterion("width is not null");
            return (Criteria) this;
        }

        public Criteria andWidthEqualTo(BigDecimal value) {
            addCriterion("width =", value, "width");
            return (Criteria) this;
        }

        public Criteria andWidthNotEqualTo(BigDecimal value) {
            addCriterion("width <>", value, "width");
            return (Criteria) this;
        }

        public Criteria andWidthGreaterThan(BigDecimal value) {
            addCriterion("width >", value, "width");
            return (Criteria) this;
        }

        public Criteria andWidthGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("width >=", value, "width");
            return (Criteria) this;
        }

        public Criteria andWidthLessThan(BigDecimal value) {
            addCriterion("width <", value, "width");
            return (Criteria) this;
        }

        public Criteria andWidthLessThanOrEqualTo(BigDecimal value) {
            addCriterion("width <=", value, "width");
            return (Criteria) this;
        }

        public Criteria andWidthIn(List<BigDecimal> values) {
            addCriterion("width in", values, "width");
            return (Criteria) this;
        }

        public Criteria andWidthNotIn(List<BigDecimal> values) {
            addCriterion("width not in", values, "width");
            return (Criteria) this;
        }

        public Criteria andWidthBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("width between", value1, value2, "width");
            return (Criteria) this;
        }

        public Criteria andWidthNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("width not between", value1, value2, "width");
            return (Criteria) this;
        }

        public Criteria andHeightIsNull() {
            addCriterion("height is null");
            return (Criteria) this;
        }

        public Criteria andHeightIsNotNull() {
            addCriterion("height is not null");
            return (Criteria) this;
        }

        public Criteria andHeightEqualTo(BigDecimal value) {
            addCriterion("height =", value, "height");
            return (Criteria) this;
        }

        public Criteria andHeightNotEqualTo(BigDecimal value) {
            addCriterion("height <>", value, "height");
            return (Criteria) this;
        }

        public Criteria andHeightGreaterThan(BigDecimal value) {
            addCriterion("height >", value, "height");
            return (Criteria) this;
        }

        public Criteria andHeightGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("height >=", value, "height");
            return (Criteria) this;
        }

        public Criteria andHeightLessThan(BigDecimal value) {
            addCriterion("height <", value, "height");
            return (Criteria) this;
        }

        public Criteria andHeightLessThanOrEqualTo(BigDecimal value) {
            addCriterion("height <=", value, "height");
            return (Criteria) this;
        }

        public Criteria andHeightIn(List<BigDecimal> values) {
            addCriterion("height in", values, "height");
            return (Criteria) this;
        }

        public Criteria andHeightNotIn(List<BigDecimal> values) {
            addCriterion("height not in", values, "height");
            return (Criteria) this;
        }

        public Criteria andHeightBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("height between", value1, value2, "height");
            return (Criteria) this;
        }

        public Criteria andHeightNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("height not between", value1, value2, "height");
            return (Criteria) this;
        }

        public Criteria andPackNumIsNull() {
            addCriterion("pack_num is null");
            return (Criteria) this;
        }

        public Criteria andPackNumIsNotNull() {
            addCriterion("pack_num is not null");
            return (Criteria) this;
        }

        public Criteria andPackNumEqualTo(String value) {
            addCriterion("pack_num =", value, "packNum");
            return (Criteria) this;
        }

        public Criteria andPackNumNotEqualTo(String value) {
            addCriterion("pack_num <>", value, "packNum");
            return (Criteria) this;
        }

        public Criteria andPackNumGreaterThan(String value) {
            addCriterion("pack_num >", value, "packNum");
            return (Criteria) this;
        }

        public Criteria andPackNumGreaterThanOrEqualTo(String value) {
            addCriterion("pack_num >=", value, "packNum");
            return (Criteria) this;
        }

        public Criteria andPackNumLessThan(String value) {
            addCriterion("pack_num <", value, "packNum");
            return (Criteria) this;
        }

        public Criteria andPackNumLessThanOrEqualTo(String value) {
            addCriterion("pack_num <=", value, "packNum");
            return (Criteria) this;
        }

        public Criteria andPackNumLike(String value) {
            addCriterion("pack_num like", value, "packNum");
            return (Criteria) this;
        }

        public Criteria andPackNumNotLike(String value) {
            addCriterion("pack_num not like", value, "packNum");
            return (Criteria) this;
        }

        public Criteria andPackNumIn(List<String> values) {
            addCriterion("pack_num in", values, "packNum");
            return (Criteria) this;
        }

        public Criteria andPackNumNotIn(List<String> values) {
            addCriterion("pack_num not in", values, "packNum");
            return (Criteria) this;
        }

        public Criteria andPackNumBetween(String value1, String value2) {
            addCriterion("pack_num between", value1, value2, "packNum");
            return (Criteria) this;
        }

        public Criteria andPackNumNotBetween(String value1, String value2) {
            addCriterion("pack_num not between", value1, value2, "packNum");
            return (Criteria) this;
        }

        public Criteria andPackAverageWeightIsNull() {
            addCriterion("pack_average_weight is null");
            return (Criteria) this;
        }

        public Criteria andPackAverageWeightIsNotNull() {
            addCriterion("pack_average_weight is not null");
            return (Criteria) this;
        }

        public Criteria andPackAverageWeightEqualTo(String value) {
            addCriterion("pack_average_weight =", value, "packAverageWeight");
            return (Criteria) this;
        }

        public Criteria andPackAverageWeightNotEqualTo(String value) {
            addCriterion("pack_average_weight <>", value, "packAverageWeight");
            return (Criteria) this;
        }

        public Criteria andPackAverageWeightGreaterThan(String value) {
            addCriterion("pack_average_weight >", value, "packAverageWeight");
            return (Criteria) this;
        }

        public Criteria andPackAverageWeightGreaterThanOrEqualTo(String value) {
            addCriterion("pack_average_weight >=", value, "packAverageWeight");
            return (Criteria) this;
        }

        public Criteria andPackAverageWeightLessThan(String value) {
            addCriterion("pack_average_weight <", value, "packAverageWeight");
            return (Criteria) this;
        }

        public Criteria andPackAverageWeightLessThanOrEqualTo(String value) {
            addCriterion("pack_average_weight <=", value, "packAverageWeight");
            return (Criteria) this;
        }

        public Criteria andPackAverageWeightLike(String value) {
            addCriterion("pack_average_weight like", value, "packAverageWeight");
            return (Criteria) this;
        }

        public Criteria andPackAverageWeightNotLike(String value) {
            addCriterion("pack_average_weight not like", value, "packAverageWeight");
            return (Criteria) this;
        }

        public Criteria andPackAverageWeightIn(List<String> values) {
            addCriterion("pack_average_weight in", values, "packAverageWeight");
            return (Criteria) this;
        }

        public Criteria andPackAverageWeightNotIn(List<String> values) {
            addCriterion("pack_average_weight not in", values, "packAverageWeight");
            return (Criteria) this;
        }

        public Criteria andPackAverageWeightBetween(String value1, String value2) {
            addCriterion("pack_average_weight between", value1, value2, "packAverageWeight");
            return (Criteria) this;
        }

        public Criteria andPackAverageWeightNotBetween(String value1, String value2) {
            addCriterion("pack_average_weight not between", value1, value2, "packAverageWeight");
            return (Criteria) this;
        }

        public Criteria andKeeperIdsIsNull() {
            addCriterion("keeper_ids is null");
            return (Criteria) this;
        }

        public Criteria andKeeperIdsIsNotNull() {
            addCriterion("keeper_ids is not null");
            return (Criteria) this;
        }

        public Criteria andKeeperIdsEqualTo(String value) {
            addCriterion("keeper_ids =", value, "keeperIds");
            return (Criteria) this;
        }

        public Criteria andKeeperIdsNotEqualTo(String value) {
            addCriterion("keeper_ids <>", value, "keeperIds");
            return (Criteria) this;
        }

        public Criteria andKeeperIdsGreaterThan(String value) {
            addCriterion("keeper_ids >", value, "keeperIds");
            return (Criteria) this;
        }

        public Criteria andKeeperIdsGreaterThanOrEqualTo(String value) {
            addCriterion("keeper_ids >=", value, "keeperIds");
            return (Criteria) this;
        }

        public Criteria andKeeperIdsLessThan(String value) {
            addCriterion("keeper_ids <", value, "keeperIds");
            return (Criteria) this;
        }

        public Criteria andKeeperIdsLessThanOrEqualTo(String value) {
            addCriterion("keeper_ids <=", value, "keeperIds");
            return (Criteria) this;
        }

        public Criteria andKeeperIdsLike(String value) {
            addCriterion("keeper_ids like", value, "keeperIds");
            return (Criteria) this;
        }

        public Criteria andKeeperIdsNotLike(String value) {
            addCriterion("keeper_ids not like", value, "keeperIds");
            return (Criteria) this;
        }

        public Criteria andKeeperIdsIn(List<String> values) {
            addCriterion("keeper_ids in", values, "keeperIds");
            return (Criteria) this;
        }

        public Criteria andKeeperIdsNotIn(List<String> values) {
            addCriterion("keeper_ids not in", values, "keeperIds");
            return (Criteria) this;
        }

        public Criteria andKeeperIdsBetween(String value1, String value2) {
            addCriterion("keeper_ids between", value1, value2, "keeperIds");
            return (Criteria) this;
        }

        public Criteria andKeeperIdsNotBetween(String value1, String value2) {
            addCriterion("keeper_ids not between", value1, value2, "keeperIds");
            return (Criteria) this;
        }

        public Criteria andGlutenWaterCountIsNull() {
            addCriterion("gluten_water_count is null");
            return (Criteria) this;
        }

        public Criteria andGlutenWaterCountIsNotNull() {
            addCriterion("gluten_water_count is not null");
            return (Criteria) this;
        }

        public Criteria andGlutenWaterCountEqualTo(String value) {
            addCriterion("gluten_water_count =", value, "glutenWaterCount");
            return (Criteria) this;
        }

        public Criteria andGlutenWaterCountNotEqualTo(String value) {
            addCriterion("gluten_water_count <>", value, "glutenWaterCount");
            return (Criteria) this;
        }

        public Criteria andGlutenWaterCountGreaterThan(String value) {
            addCriterion("gluten_water_count >", value, "glutenWaterCount");
            return (Criteria) this;
        }

        public Criteria andGlutenWaterCountGreaterThanOrEqualTo(String value) {
            addCriterion("gluten_water_count >=", value, "glutenWaterCount");
            return (Criteria) this;
        }

        public Criteria andGlutenWaterCountLessThan(String value) {
            addCriterion("gluten_water_count <", value, "glutenWaterCount");
            return (Criteria) this;
        }

        public Criteria andGlutenWaterCountLessThanOrEqualTo(String value) {
            addCriterion("gluten_water_count <=", value, "glutenWaterCount");
            return (Criteria) this;
        }

        public Criteria andGlutenWaterCountLike(String value) {
            addCriterion("gluten_water_count like", value, "glutenWaterCount");
            return (Criteria) this;
        }

        public Criteria andGlutenWaterCountNotLike(String value) {
            addCriterion("gluten_water_count not like", value, "glutenWaterCount");
            return (Criteria) this;
        }

        public Criteria andGlutenWaterCountIn(List<String> values) {
            addCriterion("gluten_water_count in", values, "glutenWaterCount");
            return (Criteria) this;
        }

        public Criteria andGlutenWaterCountNotIn(List<String> values) {
            addCriterion("gluten_water_count not in", values, "glutenWaterCount");
            return (Criteria) this;
        }

        public Criteria andGlutenWaterCountBetween(String value1, String value2) {
            addCriterion("gluten_water_count between", value1, value2, "glutenWaterCount");
            return (Criteria) this;
        }

        public Criteria andGlutenWaterCountNotBetween(String value1, String value2) {
            addCriterion("gluten_water_count not between", value1, value2, "glutenWaterCount");
            return (Criteria) this;
        }

        public Criteria andEatScoreIsNull() {
            addCriterion("eat_score is null");
            return (Criteria) this;
        }

        public Criteria andEatScoreIsNotNull() {
            addCriterion("eat_score is not null");
            return (Criteria) this;
        }

        public Criteria andEatScoreEqualTo(String value) {
            addCriterion("eat_score =", value, "eatScore");
            return (Criteria) this;
        }

        public Criteria andEatScoreNotEqualTo(String value) {
            addCriterion("eat_score <>", value, "eatScore");
            return (Criteria) this;
        }

        public Criteria andEatScoreGreaterThan(String value) {
            addCriterion("eat_score >", value, "eatScore");
            return (Criteria) this;
        }

        public Criteria andEatScoreGreaterThanOrEqualTo(String value) {
            addCriterion("eat_score >=", value, "eatScore");
            return (Criteria) this;
        }

        public Criteria andEatScoreLessThan(String value) {
            addCriterion("eat_score <", value, "eatScore");
            return (Criteria) this;
        }

        public Criteria andEatScoreLessThanOrEqualTo(String value) {
            addCriterion("eat_score <=", value, "eatScore");
            return (Criteria) this;
        }

        public Criteria andEatScoreLike(String value) {
            addCriterion("eat_score like", value, "eatScore");
            return (Criteria) this;
        }

        public Criteria andEatScoreNotLike(String value) {
            addCriterion("eat_score not like", value, "eatScore");
            return (Criteria) this;
        }

        public Criteria andEatScoreIn(List<String> values) {
            addCriterion("eat_score in", values, "eatScore");
            return (Criteria) this;
        }

        public Criteria andEatScoreNotIn(List<String> values) {
            addCriterion("eat_score not in", values, "eatScore");
            return (Criteria) this;
        }

        public Criteria andEatScoreBetween(String value1, String value2) {
            addCriterion("eat_score between", value1, value2, "eatScore");
            return (Criteria) this;
        }

        public Criteria andEatScoreNotBetween(String value1, String value2) {
            addCriterion("eat_score not between", value1, value2, "eatScore");
            return (Criteria) this;
        }

        public Criteria andUnitHeadIsNull() {
            addCriterion("unit_head is null");
            return (Criteria) this;
        }

        public Criteria andUnitHeadIsNotNull() {
            addCriterion("unit_head is not null");
            return (Criteria) this;
        }

        public Criteria andUnitHeadEqualTo(String value) {
            addCriterion("unit_head =", value, "unitHead");
            return (Criteria) this;
        }

        public Criteria andUnitHeadNotEqualTo(String value) {
            addCriterion("unit_head <>", value, "unitHead");
            return (Criteria) this;
        }

        public Criteria andUnitHeadGreaterThan(String value) {
            addCriterion("unit_head >", value, "unitHead");
            return (Criteria) this;
        }

        public Criteria andUnitHeadGreaterThanOrEqualTo(String value) {
            addCriterion("unit_head >=", value, "unitHead");
            return (Criteria) this;
        }

        public Criteria andUnitHeadLessThan(String value) {
            addCriterion("unit_head <", value, "unitHead");
            return (Criteria) this;
        }

        public Criteria andUnitHeadLessThanOrEqualTo(String value) {
            addCriterion("unit_head <=", value, "unitHead");
            return (Criteria) this;
        }

        public Criteria andUnitHeadLike(String value) {
            addCriterion("unit_head like", value, "unitHead");
            return (Criteria) this;
        }

        public Criteria andUnitHeadNotLike(String value) {
            addCriterion("unit_head not like", value, "unitHead");
            return (Criteria) this;
        }

        public Criteria andUnitHeadIn(List<String> values) {
            addCriterion("unit_head in", values, "unitHead");
            return (Criteria) this;
        }

        public Criteria andUnitHeadNotIn(List<String> values) {
            addCriterion("unit_head not in", values, "unitHead");
            return (Criteria) this;
        }

        public Criteria andUnitHeadBetween(String value1, String value2) {
            addCriterion("unit_head between", value1, value2, "unitHead");
            return (Criteria) this;
        }

        public Criteria andUnitHeadNotBetween(String value1, String value2) {
            addCriterion("unit_head not between", value1, value2, "unitHead");
            return (Criteria) this;
        }

        public Criteria andFatIndexIsNull() {
            addCriterion("fat_index is null");
            return (Criteria) this;
        }

        public Criteria andFatIndexIsNotNull() {
            addCriterion("fat_index is not null");
            return (Criteria) this;
        }

        public Criteria andFatIndexEqualTo(String value) {
            addCriterion("fat_index =", value, "fatIndex");
            return (Criteria) this;
        }

        public Criteria andFatIndexNotEqualTo(String value) {
            addCriterion("fat_index <>", value, "fatIndex");
            return (Criteria) this;
        }

        public Criteria andFatIndexGreaterThan(String value) {
            addCriterion("fat_index >", value, "fatIndex");
            return (Criteria) this;
        }

        public Criteria andFatIndexGreaterThanOrEqualTo(String value) {
            addCriterion("fat_index >=", value, "fatIndex");
            return (Criteria) this;
        }

        public Criteria andFatIndexLessThan(String value) {
            addCriterion("fat_index <", value, "fatIndex");
            return (Criteria) this;
        }

        public Criteria andFatIndexLessThanOrEqualTo(String value) {
            addCriterion("fat_index <=", value, "fatIndex");
            return (Criteria) this;
        }

        public Criteria andFatIndexLike(String value) {
            addCriterion("fat_index like", value, "fatIndex");
            return (Criteria) this;
        }

        public Criteria andFatIndexNotLike(String value) {
            addCriterion("fat_index not like", value, "fatIndex");
            return (Criteria) this;
        }

        public Criteria andFatIndexIn(List<String> values) {
            addCriterion("fat_index in", values, "fatIndex");
            return (Criteria) this;
        }

        public Criteria andFatIndexNotIn(List<String> values) {
            addCriterion("fat_index not in", values, "fatIndex");
            return (Criteria) this;
        }

        public Criteria andFatIndexBetween(String value1, String value2) {
            addCriterion("fat_index between", value1, value2, "fatIndex");
            return (Criteria) this;
        }

        public Criteria andFatIndexNotBetween(String value1, String value2) {
            addCriterion("fat_index not between", value1, value2, "fatIndex");
            return (Criteria) this;
        }

        public Criteria andPeroxideValueIsNull() {
            addCriterion("peroxide_value is null");
            return (Criteria) this;
        }

        public Criteria andPeroxideValueIsNotNull() {
            addCriterion("peroxide_value is not null");
            return (Criteria) this;
        }

        public Criteria andPeroxideValueEqualTo(String value) {
            addCriterion("peroxide_value =", value, "peroxideValue");
            return (Criteria) this;
        }

        public Criteria andPeroxideValueNotEqualTo(String value) {
            addCriterion("peroxide_value <>", value, "peroxideValue");
            return (Criteria) this;
        }

        public Criteria andPeroxideValueGreaterThan(String value) {
            addCriterion("peroxide_value >", value, "peroxideValue");
            return (Criteria) this;
        }

        public Criteria andPeroxideValueGreaterThanOrEqualTo(String value) {
            addCriterion("peroxide_value >=", value, "peroxideValue");
            return (Criteria) this;
        }

        public Criteria andPeroxideValueLessThan(String value) {
            addCriterion("peroxide_value <", value, "peroxideValue");
            return (Criteria) this;
        }

        public Criteria andPeroxideValueLessThanOrEqualTo(String value) {
            addCriterion("peroxide_value <=", value, "peroxideValue");
            return (Criteria) this;
        }

        public Criteria andPeroxideValueLike(String value) {
            addCriterion("peroxide_value like", value, "peroxideValue");
            return (Criteria) this;
        }

        public Criteria andPeroxideValueNotLike(String value) {
            addCriterion("peroxide_value not like", value, "peroxideValue");
            return (Criteria) this;
        }

        public Criteria andPeroxideValueIn(List<String> values) {
            addCriterion("peroxide_value in", values, "peroxideValue");
            return (Criteria) this;
        }

        public Criteria andPeroxideValueNotIn(List<String> values) {
            addCriterion("peroxide_value not in", values, "peroxideValue");
            return (Criteria) this;
        }

        public Criteria andPeroxideValueBetween(String value1, String value2) {
            addCriterion("peroxide_value between", value1, value2, "peroxideValue");
            return (Criteria) this;
        }

        public Criteria andPeroxideValueNotBetween(String value1, String value2) {
            addCriterion("peroxide_value not between", value1, value2, "peroxideValue");
            return (Criteria) this;
        }

        public Criteria andRefractionIndexIsNull() {
            addCriterion("refraction_index is null");
            return (Criteria) this;
        }

        public Criteria andRefractionIndexIsNotNull() {
            addCriterion("refraction_index is not null");
            return (Criteria) this;
        }

        public Criteria andRefractionIndexEqualTo(String value) {
            addCriterion("refraction_index =", value, "refractionIndex");
            return (Criteria) this;
        }

        public Criteria andRefractionIndexNotEqualTo(String value) {
            addCriterion("refraction_index <>", value, "refractionIndex");
            return (Criteria) this;
        }

        public Criteria andRefractionIndexGreaterThan(String value) {
            addCriterion("refraction_index >", value, "refractionIndex");
            return (Criteria) this;
        }

        public Criteria andRefractionIndexGreaterThanOrEqualTo(String value) {
            addCriterion("refraction_index >=", value, "refractionIndex");
            return (Criteria) this;
        }

        public Criteria andRefractionIndexLessThan(String value) {
            addCriterion("refraction_index <", value, "refractionIndex");
            return (Criteria) this;
        }

        public Criteria andRefractionIndexLessThanOrEqualTo(String value) {
            addCriterion("refraction_index <=", value, "refractionIndex");
            return (Criteria) this;
        }

        public Criteria andRefractionIndexLike(String value) {
            addCriterion("refraction_index like", value, "refractionIndex");
            return (Criteria) this;
        }

        public Criteria andRefractionIndexNotLike(String value) {
            addCriterion("refraction_index not like", value, "refractionIndex");
            return (Criteria) this;
        }

        public Criteria andRefractionIndexIn(List<String> values) {
            addCriterion("refraction_index in", values, "refractionIndex");
            return (Criteria) this;
        }

        public Criteria andRefractionIndexNotIn(List<String> values) {
            addCriterion("refraction_index not in", values, "refractionIndex");
            return (Criteria) this;
        }

        public Criteria andRefractionIndexBetween(String value1, String value2) {
            addCriterion("refraction_index between", value1, value2, "refractionIndex");
            return (Criteria) this;
        }

        public Criteria andRefractionIndexNotBetween(String value1, String value2) {
            addCriterion("refraction_index not between", value1, value2, "refractionIndex");
            return (Criteria) this;
        }

        public Criteria andResidualSolventIsNull() {
            addCriterion("residual_solvent is null");
            return (Criteria) this;
        }

        public Criteria andResidualSolventIsNotNull() {
            addCriterion("residual_solvent is not null");
            return (Criteria) this;
        }

        public Criteria andResidualSolventEqualTo(String value) {
            addCriterion("residual_solvent =", value, "residualSolvent");
            return (Criteria) this;
        }

        public Criteria andResidualSolventNotEqualTo(String value) {
            addCriterion("residual_solvent <>", value, "residualSolvent");
            return (Criteria) this;
        }

        public Criteria andResidualSolventGreaterThan(String value) {
            addCriterion("residual_solvent >", value, "residualSolvent");
            return (Criteria) this;
        }

        public Criteria andResidualSolventGreaterThanOrEqualTo(String value) {
            addCriterion("residual_solvent >=", value, "residualSolvent");
            return (Criteria) this;
        }

        public Criteria andResidualSolventLessThan(String value) {
            addCriterion("residual_solvent <", value, "residualSolvent");
            return (Criteria) this;
        }

        public Criteria andResidualSolventLessThanOrEqualTo(String value) {
            addCriterion("residual_solvent <=", value, "residualSolvent");
            return (Criteria) this;
        }

        public Criteria andResidualSolventLike(String value) {
            addCriterion("residual_solvent like", value, "residualSolvent");
            return (Criteria) this;
        }

        public Criteria andResidualSolventNotLike(String value) {
            addCriterion("residual_solvent not like", value, "residualSolvent");
            return (Criteria) this;
        }

        public Criteria andResidualSolventIn(List<String> values) {
            addCriterion("residual_solvent in", values, "residualSolvent");
            return (Criteria) this;
        }

        public Criteria andResidualSolventNotIn(List<String> values) {
            addCriterion("residual_solvent not in", values, "residualSolvent");
            return (Criteria) this;
        }

        public Criteria andResidualSolventBetween(String value1, String value2) {
            addCriterion("residual_solvent between", value1, value2, "residualSolvent");
            return (Criteria) this;
        }

        public Criteria andResidualSolventNotBetween(String value1, String value2) {
            addCriterion("residual_solvent not between", value1, value2, "residualSolvent");
            return (Criteria) this;
        }

        public Criteria andFillingTimeIsNull() {
            addCriterion("filling_time is null");
            return (Criteria) this;
        }

        public Criteria andFillingTimeIsNotNull() {
            addCriterion("filling_time is not null");
            return (Criteria) this;
        }

        public Criteria andFillingTimeEqualTo(String value) {
            addCriterion("filling_time =", value, "fillingTime");
            return (Criteria) this;
        }

        public Criteria andFillingTimeNotEqualTo(String value) {
            addCriterion("filling_time <>", value, "fillingTime");
            return (Criteria) this;
        }

        public Criteria andFillingTimeGreaterThan(String value) {
            addCriterion("filling_time >", value, "fillingTime");
            return (Criteria) this;
        }

        public Criteria andFillingTimeGreaterThanOrEqualTo(String value) {
            addCriterion("filling_time >=", value, "fillingTime");
            return (Criteria) this;
        }

        public Criteria andFillingTimeLessThan(String value) {
            addCriterion("filling_time <", value, "fillingTime");
            return (Criteria) this;
        }

        public Criteria andFillingTimeLessThanOrEqualTo(String value) {
            addCriterion("filling_time <=", value, "fillingTime");
            return (Criteria) this;
        }

        public Criteria andFillingTimeLike(String value) {
            addCriterion("filling_time like", value, "fillingTime");
            return (Criteria) this;
        }

        public Criteria andFillingTimeNotLike(String value) {
            addCriterion("filling_time not like", value, "fillingTime");
            return (Criteria) this;
        }

        public Criteria andFillingTimeIn(List<String> values) {
            addCriterion("filling_time in", values, "fillingTime");
            return (Criteria) this;
        }

        public Criteria andFillingTimeNotIn(List<String> values) {
            addCriterion("filling_time not in", values, "fillingTime");
            return (Criteria) this;
        }

        public Criteria andFillingTimeBetween(String value1, String value2) {
            addCriterion("filling_time between", value1, value2, "fillingTime");
            return (Criteria) this;
        }

        public Criteria andFillingTimeNotBetween(String value1, String value2) {
            addCriterion("filling_time not between", value1, value2, "fillingTime");
            return (Criteria) this;
        }

        public Criteria andLineHeightIsNull() {
            addCriterion("line_height is null");
            return (Criteria) this;
        }

        public Criteria andLineHeightIsNotNull() {
            addCriterion("line_height is not null");
            return (Criteria) this;
        }

        public Criteria andLineHeightEqualTo(BigDecimal value) {
            addCriterion("line_height =", value, "lineHeight");
            return (Criteria) this;
        }

        public Criteria andLineHeightNotEqualTo(BigDecimal value) {
            addCriterion("line_height <>", value, "lineHeight");
            return (Criteria) this;
        }

        public Criteria andLineHeightGreaterThan(BigDecimal value) {
            addCriterion("line_height >", value, "lineHeight");
            return (Criteria) this;
        }

        public Criteria andLineHeightGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("line_height >=", value, "lineHeight");
            return (Criteria) this;
        }

        public Criteria andLineHeightLessThan(BigDecimal value) {
            addCriterion("line_height <", value, "lineHeight");
            return (Criteria) this;
        }

        public Criteria andLineHeightLessThanOrEqualTo(BigDecimal value) {
            addCriterion("line_height <=", value, "lineHeight");
            return (Criteria) this;
        }

        public Criteria andLineHeightIn(List<BigDecimal> values) {
            addCriterion("line_height in", values, "lineHeight");
            return (Criteria) this;
        }

        public Criteria andLineHeightNotIn(List<BigDecimal> values) {
            addCriterion("line_height not in", values, "lineHeight");
            return (Criteria) this;
        }

        public Criteria andLineHeightBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("line_height between", value1, value2, "lineHeight");
            return (Criteria) this;
        }

        public Criteria andLineHeightNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("line_height not between", value1, value2, "lineHeight");
            return (Criteria) this;
        }

        public Criteria andSealStatusIsNull() {
            addCriterion("seal_status is null");
            return (Criteria) this;
        }

        public Criteria andSealStatusIsNotNull() {
            addCriterion("seal_status is not null");
            return (Criteria) this;
        }

        public Criteria andSealStatusEqualTo(String value) {
            addCriterion("seal_status =", value, "sealStatus");
            return (Criteria) this;
        }

        public Criteria andSealStatusNotEqualTo(String value) {
            addCriterion("seal_status <>", value, "sealStatus");
            return (Criteria) this;
        }

        public Criteria andSealStatusGreaterThan(String value) {
            addCriterion("seal_status >", value, "sealStatus");
            return (Criteria) this;
        }

        public Criteria andSealStatusGreaterThanOrEqualTo(String value) {
            addCriterion("seal_status >=", value, "sealStatus");
            return (Criteria) this;
        }

        public Criteria andSealStatusLessThan(String value) {
            addCriterion("seal_status <", value, "sealStatus");
            return (Criteria) this;
        }

        public Criteria andSealStatusLessThanOrEqualTo(String value) {
            addCriterion("seal_status <=", value, "sealStatus");
            return (Criteria) this;
        }

        public Criteria andSealStatusLike(String value) {
            addCriterion("seal_status like", value, "sealStatus");
            return (Criteria) this;
        }

        public Criteria andSealStatusNotLike(String value) {
            addCriterion("seal_status not like", value, "sealStatus");
            return (Criteria) this;
        }

        public Criteria andSealStatusIn(List<String> values) {
            addCriterion("seal_status in", values, "sealStatus");
            return (Criteria) this;
        }

        public Criteria andSealStatusNotIn(List<String> values) {
            addCriterion("seal_status not in", values, "sealStatus");
            return (Criteria) this;
        }

        public Criteria andSealStatusBetween(String value1, String value2) {
            addCriterion("seal_status between", value1, value2, "sealStatus");
            return (Criteria) this;
        }

        public Criteria andSealStatusNotBetween(String value1, String value2) {
            addCriterion("seal_status not between", value1, value2, "sealStatus");
            return (Criteria) this;
        }

        public Criteria andAuthCodeIsNull() {
            addCriterion("auth_code is null");
            return (Criteria) this;
        }

        public Criteria andAuthCodeIsNotNull() {
            addCriterion("auth_code is not null");
            return (Criteria) this;
        }

        public Criteria andAuthCodeEqualTo(String value) {
            addCriterion("auth_code =", value, "authCode");
            return (Criteria) this;
        }

        public Criteria andAuthCodeNotEqualTo(String value) {
            addCriterion("auth_code <>", value, "authCode");
            return (Criteria) this;
        }

        public Criteria andAuthCodeGreaterThan(String value) {
            addCriterion("auth_code >", value, "authCode");
            return (Criteria) this;
        }

        public Criteria andAuthCodeGreaterThanOrEqualTo(String value) {
            addCriterion("auth_code >=", value, "authCode");
            return (Criteria) this;
        }

        public Criteria andAuthCodeLessThan(String value) {
            addCriterion("auth_code <", value, "authCode");
            return (Criteria) this;
        }

        public Criteria andAuthCodeLessThanOrEqualTo(String value) {
            addCriterion("auth_code <=", value, "authCode");
            return (Criteria) this;
        }

        public Criteria andAuthCodeLike(String value) {
            addCriterion("auth_code like", value, "authCode");
            return (Criteria) this;
        }

        public Criteria andAuthCodeNotLike(String value) {
            addCriterion("auth_code not like", value, "authCode");
            return (Criteria) this;
        }

        public Criteria andAuthCodeIn(List<String> values) {
            addCriterion("auth_code in", values, "authCode");
            return (Criteria) this;
        }

        public Criteria andAuthCodeNotIn(List<String> values) {
            addCriterion("auth_code not in", values, "authCode");
            return (Criteria) this;
        }

        public Criteria andAuthCodeBetween(String value1, String value2) {
            addCriterion("auth_code between", value1, value2, "authCode");
            return (Criteria) this;
        }

        public Criteria andAuthCodeNotBetween(String value1, String value2) {
            addCriterion("auth_code not between", value1, value2, "authCode");
            return (Criteria) this;
        }

        public Criteria andOrgIdIsNull() {
            addCriterion("org_id is null");
            return (Criteria) this;
        }

        public Criteria andOrgIdIsNotNull() {
            addCriterion("org_id is not null");
            return (Criteria) this;
        }

        public Criteria andOrgIdEqualTo(Integer value) {
            addCriterion("org_id =", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdNotEqualTo(Integer value) {
            addCriterion("org_id <>", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdGreaterThan(Integer value) {
            addCriterion("org_id >", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("org_id >=", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdLessThan(Integer value) {
            addCriterion("org_id <", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdLessThanOrEqualTo(Integer value) {
            addCriterion("org_id <=", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdIn(List<Integer> values) {
            addCriterion("org_id in", values, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdNotIn(List<Integer> values) {
            addCriterion("org_id not in", values, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdBetween(Integer value1, Integer value2) {
            addCriterion("org_id between", value1, value2, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdNotBetween(Integer value1, Integer value2) {
            addCriterion("org_id not between", value1, value2, "orgId");
            return (Criteria) this;
        }

        public Criteria andHistoryStatusIsNull() {
            addCriterion("history_status is null");
            return (Criteria) this;
        }

        public Criteria andHistoryStatusIsNotNull() {
            addCriterion("history_status is not null");
            return (Criteria) this;
        }

        public Criteria andHistoryStatusEqualTo(Integer value) {
            addCriterion("history_status =", value, "historyStatus");
            return (Criteria) this;
        }

        public Criteria andHistoryStatusNotEqualTo(Integer value) {
            addCriterion("history_status <>", value, "historyStatus");
            return (Criteria) this;
        }

        public Criteria andHistoryStatusGreaterThan(Integer value) {
            addCriterion("history_status >", value, "historyStatus");
            return (Criteria) this;
        }

        public Criteria andHistoryStatusGreaterThanOrEqualTo(Integer value) {
            addCriterion("history_status >=", value, "historyStatus");
            return (Criteria) this;
        }

        public Criteria andHistoryStatusLessThan(Integer value) {
            addCriterion("history_status <", value, "historyStatus");
            return (Criteria) this;
        }

        public Criteria andHistoryStatusLessThanOrEqualTo(Integer value) {
            addCriterion("history_status <=", value, "historyStatus");
            return (Criteria) this;
        }

        public Criteria andHistoryStatusIn(List<Integer> values) {
            addCriterion("history_status in", values, "historyStatus");
            return (Criteria) this;
        }

        public Criteria andHistoryStatusNotIn(List<Integer> values) {
            addCriterion("history_status not in", values, "historyStatus");
            return (Criteria) this;
        }

        public Criteria andHistoryStatusBetween(Integer value1, Integer value2) {
            addCriterion("history_status between", value1, value2, "historyStatus");
            return (Criteria) this;
        }

        public Criteria andHistoryStatusNotBetween(Integer value1, Integer value2) {
            addCriterion("history_status not between", value1, value2, "historyStatus");
            return (Criteria) this;
        }
    }

    /**
     * storage_foodbasicinfo
     */
    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    /**
     * storage_foodbasicinfo 2018-05-04
     */
    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}